;----------------------INTEGRATION Module-----------------------------------------------	

	in	R16,TCNT1L		;Load	to R16 low byte (RL) of digit from TC1
	in	R17,TCNT1H		;Load	to R17 high byte of digit from TC1
	mov	r18,TC1			;Load	to R18 high byte (RH) of real digit

	
	lds	r19,ACKK		;
	tst	r19			;	
	breq	IN11			;If SHUP connected then devide 4

	clc				;
	rol	r16			;
	rol	r17			;
	rol	r18			;Divide 2
		
IN11:	ldi	YL,low(BUFFER)		;
	ldi	YH,high(BUFFER)	;Adress of "BUFFER" to Y
	lds	r22,pointer		;Load	to R22 POINTER

IN5:	ld	r19,Y+			;                        (RL)
	ld	r20,Y+			;
	ld	r21,Y+			;Previous digit loading  (RH)
	dec	r22			;DEC Pointer
	tst	r22
	brne	IN5

	sub	r19,r16			;
	sbc	r20,r17			;		
	sbc	r21,r18			;Substraction [BUFFER(i-1)-BUFFER(i)]	
	
	ldi	r22,0x03		;Load to R23 POROG=3 |
	add	r19,r22			;                    |
	clr	r22			;Load to R23 0x00    |
	adc	r20,r22			;                    |
	adc	r21,r22			;                    |[BUFFER(i-1)-BUFFER(i)]+[POROG=3]	

	cpi	r19,0x06		;Compare Result with 2*POROG=6
	in	r22,SREG		;
	andi	r22,0b11111011		;
	out	SREG,r22		;ABS
	brlo	IN3			;If LOWER then 2*POROG=6 goto DO6

;========================== |...| => Porog=3 ===============================

	ldi	YL,low(BUFFER)		;
	ldi	YH,high(BUFFER)	;Adress of "BUFFER" to Y

	ldi	r19,10			;Counter=10

IN1:	st	Y+,R16			;	
	st	Y+,R17			;
	st	Y+,R18			;Store DIGIT to RAM with post adr INC
	dec	r19			;Counter=Counter-1
	brne	IN1			;If not ZERO goto DO7

IN6:	ldi	r22,0x01
	sts	Pointer,r22		;Pointer=2
	
	rjmp	IN4

;========================== |...| < Porog=3 ================================

IN3:	lds	r22,pointer		;Load	to R22 POINTER

	cpi	r22,10
	brne	IN7	

	ldi	YL,low(BUFFER)		;
	ldi	YH,high(BUFFER)	;Adress of "BUFFER" to Y

	st	Y+,R16			;               (RL)
	st	Y+,R17			;
	st	Y+,R18			; digit SAVING  (RH)	

	rjmp	IN6


IN7:	st	Y+,R16			;               (RL)
	st	Y+,R17			;
	st	Y+,R18			; digit SAVING  (RH)	

	inc	r22
	sts	pointer	,r22

	rjmp	IN8

;========================= Summorizing =====================================

IN4:	ldi	r19,9			;Counter=9
	ldi	YL,low(BUFFER)		;
	ldi	YH,high(BUFFER)	;Adress of BUFFER to Y
	
	ld	r20,Y+			;               (RL)
	ld	r21,Y+			;
	ld	r22,Y+			;Digit loading  (RH)

IN2:	ld	r16,Y+			;               (RL)
	ld	r17,Y+			;
	ld	r18,Y+			;Digit loading  (RH)

	add	r20,r16			;
	adc	r21,r17			;
	adc	r22,r18			;Summorizing

	dec	r19			;Counter=Counter-1
	brne	IN2			;If not ZERO goto DO7

;=========================  Constant ADDITION ==============================
	
	rcall	DEC_2_BIN		;

	lds	r16,DIGIT_BIN_M	;				(RL)
	lds	r17,DIGIT_BIN_M+1	;
	lds	r18,DIGIT_BIN_M+2	;Load constant from memory	(RH)
	lds	r19,DIGIT_BIN_M+3	;SIGN (10 - minus / 11 - plus)

	cpi	r19,0x11
	breq	IN10			;POSITIVE?
	
	com	r18			;
	com	r17			;
	com	r16			;
	ldi	r23,0x01		;
	clr	r24			;
	add	r16,r23			;
	adc	r17,r24			;
	adc	r18,r24			;NEGATIVE digit FORMING

	tst	r18			;
	brne	IN10			;
	tst	r17			;
	brne	IN10			;
	tst	r16			;
	brne	IN10			;
	ldi	r19,0x11		;TEST (-0)

IN10:	add	r20,r16			;
	adc	r21,r17			;
	adc	r22,r18			;Summorizing

	sbrc	r19,0			;Positive/negative?
	rjmp	IN9			;
	brcs	IN9			;Goto IN9 if Carry SET

	clr	r20
	clr	r21
	clr	r22

IN9:	sts	DIGIT_BIN+1,R20	;
	sts	DIGIT_BIN+2,R21	;
	sts	DIGIT_BIN+3,R22	;
	ldi	r16,0x80		;
	sts	DIGIT_BIN,r16		;Reconstructered digit to RAM for needed decoding [+0.5]

IN8:
;------------------------ END -----------------------------------------------	
	

	
