;----------------------------------------------------------------------------
;                    I N T E R R U P T     P R O G R A M M                   
;----------------------------------------------------------------------------


;============================== Entrance ====================================

TimeKey:	;sei			;global INT enable	

		push	r16		;push R16

		clr	r16		;
		out	MCUCR,r16	;SLEEP DISable
	
		ldi	r16,99
		out	TCNT0,r16	;T/C0 start from 99
	
		in	r16,sreg	;push sreg
		push	r16		;push sreg

		push	XL		;
		push	XH		;
		push	YL		;
		push	YH		;
		push	R17		;
		push	R18		;
		push	R19		;
		push	R20		;
		push	R21		;
		push	R22		;
		push	R23		;
		push	R24		;
		push	R25		;
		push	R0		;Push Rx in STACK

;============================ BUTTONS CAPTURE ===============================

		in	BUTTON,PIND
		ldi	r16,0b00001100
		and	BUTTON,r16

;===================== Display selection (LOGO or Fr.) =====================

		tst	LOGO		;LOGO = 0?
		breq	DS1
		rjmp	DS2
DS1:		rjmp	DS3

;============================== Counter =====================================
		
DS2:		ldi	r16,0b00000111	;
		out	TCCR1B,r16	;T/C1 start	

		lds	r16,Count	;
		inc	r16		;
		sts	Count,r16	;INC Count

		cpi	r16,41		;Compare Count & 41
		brne	co1
		rjmp	co2
co1:		rjmp	co3
	
co2:		clr	r16		;
		out	TCCR1B,r16	;T/C1-Stop
		
		.include "INTEG.asm"	
		
		clr	TC1
		sts	Count,TC1	;Count=0
		out	TCNT1H,TC1	;00=>T/C1 
		out	TCNT1L,TC1	;00=>T/C1
		
		rcall	BIN_2_DEC		;
		rcall	DEC_2_7SEG		;
		rcall	ZERO_CORRECTION	;Digit`s restructure
		
co3:		sei				;GLOBAL INT ENABLE

;===================== HardWare DIGIT DISPLAY ===============================
				
DS3:		lds	r18,IND_COUNT		;Get IND_COUNT from RAM
		lds	XL,IND_ADR		;Get IND_ADR from RAM
		
	;---------	DIGIT ROLLING -------------------------------------

		in	r16,PORTB		;GET PORTB State
		
		cpi	r18,8			;Compare IND_COUNT & 8 (number of digits displayed)
		brne	TK4			;If NOT goto TK4
		
		ldi	XL,DIGIT_CORR		;Store BEGIN of DIGITS in XL

		clr	r18			;Clear IND_COUNT
		clc				;CLEAR CARRY Flag
		rjmp	TK5
TK4:		sec				;SET CARRY Flag
TK5:		rol	r16			;ROL r17
		out	PORTB,r16		;r16 OUT to PORTB
				
		inc	r18			;INC IND_COUNT
		ld	R16,X+			;Load data to R16 from adress X 
		sts	IND_COUNT,r18		;STORE IND_COUNT to RAM
		sts	IND_ADR,XL		;STORE	IND_ADR to RAM
	
	;------------------	DIGIT OUT THRUE 74HC164	---------------

		ldi	r17,8
TK1:		rol	r16			;ROL DIGIT_7SEG thrue CARRY
		brcc	TK2			;If C=0 goto TK2
		sbi	PORTD,IND_DATA		;DATA "1" for 74LS164
		rjmp	TK3
TK2:		cbi	PORTD,IND_DATA		;DATA "0" for 74LS164
TK3:		sbi 	PORTD,IND_CLOCK	;
		cbi 	PORTD,IND_CLOCK	;CLOCK for 74LS164
		dec	r17
		brne	TK1

	
;===========================    I2C    =====================================

		clr	ACK

		rcall	I2CSTART		;BEGIN OF TRANSFER
		ldi	r16,0b11000010		;RD Addr PLL => I2C
		rcall	I2COUT			;Exequte 
		sts	ACKK,ACK		;	

		ldi	r16,0b00000001		;
		rcall	I2COUT			; 
		ldi	r16,0b00000000		;	
		rcall	I2COUT			;Write K=256 (8*K=2048)

		ldi	r16,0b10101110		;
		rcall	I2COUT			; 
		ldi	r16,0b00000000		;
		rcall	I2COUT			; 

		rcall	I2CSTOP			;END OF TRANSFER

;============================= DELAY 025s ==================================

		tst	DEL25
		breq	EXIT
		dec	DEL25
		rjmp	EXIT
		
;============================== EXIT =======================================
	
EXIT:		pop	r0		;
		pop	r25		;
		pop	R24	
		pop	r23		;
		pop	r22		;
		pop	r21		;
		pop	r20		;
		pop	R19		;
		pop	R18		;
		pop	R17		;
		pop	YH		;
		pop	YL		;
		pop	XH		;
		pop	XL		;
		pop	r16		;Pop Rx from STACK

		out	sreg,r16	;Pop sreg
		pop	r16		;pop R16

		RETI
